Package lxml :: Module ElementInclude |
[hide private]
[frames] | no frames]

# Source Code for Module lxml.ElementInclude

      1  #
      2  # ElementTree
      3  # $Id: ElementInclude.py 1862 2004-06-18 07:31:02Z Fredrik $
      4  #
      5  # limited xinclude support for element trees
      6  #
      7  # history:
      8  # 2003-08-15 fl   created
      9  # 2003-11-14 fl   fixed default loader
     10  #
     11  # Copyright (c) 2003-2004 by Fredrik Lundh.  All rights reserved.
     12  #
     13  # fredrik@pythonware.com
     14  # http://www.pythonware.com
     15  #
     16  # --------------------------------------------------------------------
     17  # The ElementTree toolkit is
     18  #
     19  # Copyright (c) 1999-2004 by Fredrik Lundh
     20  #
     21  # By obtaining, using, and/or copying this software and/or its
     22  # associated documentation, you agree that you have read, understood,
     23  # and will comply with the following terms and conditions:
     24  #
     25  # Permission to use, copy, modify, and distribute this software and
     26  # its associated documentation for any purpose and without fee is
     27  # hereby granted, provided that the above copyright notice appears in
     28  # all copies, and that both that copyright notice and this permission
     29  # notice appear in supporting documentation, and that the name of
     30  # Secret Labs AB or the author not be used in advertising or publicity
     31  # pertaining to distribution of the software without specific, written
     32  # prior permission.
     33  #
     34  # SECRET LABS AB AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD
     35  # TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANT-
     36  # ABILITY AND FITNESS.  IN NO EVENT SHALL SECRET LABS AB OR THE AUTHOR
     37  # BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
     38  # DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
     39  # WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
     40  # ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
     41  # OF THIS SOFTWARE.
     42  # --------------------------------------------------------------------
     43
     44  """
     45  Limited XInclude support for the ElementTree package.
     46
     47  While lxml.etree has full support for XInclude (see
     48  `etree.ElementTree.xinclude()`), this module provides a simpler, pure
     49  Python, ElementTree compatible implementation that supports a simple
     50  form of custom URL resolvers.
     51  """
     52
     53  from lxml import etree
     54  import copy
     55  try:
     56      from urlparse import urljoin
     57      from urllib2 import urlopen
     58  except ImportError:
     59      # Python 3
     60      from urllib.parse import urljoin
     61      from urllib.request import urlopen
     62
     63  try:
     64      set
     65  except NameError:
     66      # Python 2.3
     67      from sets import Set as set
     68
     69  XINCLUDE = "{http://www.w3.org/2001/XInclude}"
     70
     71  XINCLUDE_INCLUDE = XINCLUDE + "include"
     72  XINCLUDE_FALLBACK = XINCLUDE + "fallback"
     73
     74  ##
     75  # Fatal include error.
     76
     77 -class FatalIncludeError(etree.LxmlSyntaxError):
     78      pass
     79
     80  ##
     81  # ET compatible default loader.
     82  # This loader reads an included resource from disk.
     83  #
     84  # @param href Resource reference.
     85  # @param parse Parse mode.  Either "xml" or "text".
     86  # @param encoding Optional text encoding.
     87  # @return The expanded resource.  If the parse mode is "xml", this
     88  #    is an ElementTree instance.  If the parse mode is "text", this
     89  #    is a Unicode string.  If the loader fails, it can return None
     90  #    or raise an IOError exception.
     91  # @throws IOError If the loader fails to load the resource.
     92
     93 -def default_loader(href, parse, encoding=None):
     94      file = open(href, 'rb')
     95      if parse == "xml":
     96          data = etree.parse(file).getroot()
     97      else:
     98          data = file.read()
     99          if not encoding:
    100              encoding = 'utf-8'
    101          data = data.decode(encoding)
    102      file.close()
    103      return data
    104
    105  ##
    106  # Default loader used by lxml.etree - handles custom resolvers properly
    107  #
    108
    109 -def _lxml_default_loader(href, parse, encoding=None, parser=None):
    110      if parse == "xml":
    111          data = etree.parse(href, parser).getroot()
    112      else:
    113          if "://" in href:
    114              f = urlopen(href)
    115          else:
    116              f = open(href, 'rb')
    117          data = f.read()
    118          f.close()
    119          if not encoding:
    120              encoding = 'utf-8'
    121          data = data.decode(encoding)
    122      return data
    123
    124  ##
    125  # Wrapper for ET compatibility - drops the parser
    126
    127 -def _wrap_et_loader(loader):
    128      def load(href, parse, encoding=None, parser=None):
    129          return loader(href, parse, encoding)
    130      return load
    131
    132
    133  ##
    134  # Expand XInclude directives.
    135  #
    136  # @param elem Root element.
    137  # @param loader Optional resource loader.  If omitted, it defaults
    138  #     to {@link default_loader}.  If given, it should be a callable
    139  #     that implements the same interface as <b>default_loader</b>.
    140  # @throws FatalIncludeError If the function fails to include a given
    141  #     resource, or if the tree contains malformed XInclude elements.
    142  # @throws IOError If the function fails to load a given resource.
    143  # @returns the node or its replacement if it was an XInclude node
    144
    145 -def include(elem, loader=None, base_url=None):
    146      if base_url is None:
    147          if hasattr(elem, 'getroot'):
    148              tree = elem
    149              elem = elem.getroot()
    150          else:
    151              tree = elem.getroottree()
    152          if hasattr(tree, 'docinfo'):
    153              base_url = tree.docinfo.URL
    154      elif hasattr(elem, 'getroot'):
    155          elem = elem.getroot()
    156      _include(elem, loader, base_url=base_url)
    157
    158 -def _include(elem, loader=None, _parent_hrefs=None, base_url=None):
    159      if loader is not None:
    160          load_include = _wrap_et_loader(loader)
    161      else:
    162          load_include = _lxml_default_loader
    163
    164      if _parent_hrefs is None:
    165          _parent_hrefs = set()
    166
    167      parser = elem.getroottree().parser
    168
    169      include_elements = list(
    170          elem.iter('{http://www.w3.org/2001/XInclude}*'))
    171
    172      for e in include_elements:
    173          if e.tag == XINCLUDE_INCLUDE:
    174              # process xinclude directive
    175              href = urljoin(base_url, e.get("href"))
    176              parse = e.get("parse", "xml")
    177              parent = e.getparent()
    178              if parse == "xml":
    179                  if href in _parent_hrefs:
    180                      raise FatalIncludeError(
    181                          "recursive include of %r detected" % href
    182                          )
    183                  _parent_hrefs.add(href)
    184                  node = load_include(href, parse, parser=parser)
    185                  if node is None:
    186                      raise FatalIncludeError(
    187                          "cannot load %r as %r" % (href, parse)
    188                          )
    189                  node = _include(node, loader, _parent_hrefs)
    190                  if e.tail:
    191                      node.tail = (node.tail or "") + e.tail
    192                  if parent is None:
    193                      return node # replaced the root node!
    194                  parent.replace(e, node)
    195              elif parse == "text":
    196                  text = load_include(href, parse, encoding=e.get("encoding"))
    197                  if text is None:
    198                      raise FatalIncludeError(
    199                          "cannot load %r as %r" % (href, parse)
    200                          )
    201                  predecessor = e.getprevious()
    202                  if predecessor is not None:
    203                      predecessor.tail = (predecessor.tail or "") + text
    204                  elif parent is None:
    205                      return text # replaced the root node!
    206                  else:
    207                      parent.text = (parent.text or "") + text + (e.tail or "")
    208                  parent.remove(e)
    209              else:
    210                  raise FatalIncludeError(
    211                      "unknown parse type in xi:include tag (%r)" % parse
    212                  )
    213          elif e.tag == XINCLUDE_FALLBACK:
    214              parent = e.getparent()
    215              if parent is not None and parent.tag != XINCLUDE_INCLUDE:
    216                  raise FatalIncludeError(
    217                      "xi:fallback tag must be child of xi:include (%r)" % e.tag
    218                      )
    219          else:
    220              raise FatalIncludeError(
    221                  "Invalid element found in XInclude namespace (%r)" % e.tag
    222                  )
    223      return elem
    224